- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# aws_waf_rule – create and delete WAF Rules

New in version 2.5.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Read the AWS documentation for WAF https://aws.amazon.com/documentation/waf/

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6

- boto

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
conditions - |  | list of conditions used in the rule. Each condition should contain type: which is one of [`byte`, `geo`, `ip`, `size`, `sql` or `xss`] negated: whether the condition should be negated, and `condition`, the name of the existing condition. aws_waf_condition can be used to create new conditions
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
metric_name - |  | A friendly name or description for the metrics for the rule The name can contain only alphanumeric characters (A-Z, a-z, 0-9); the name can't contain whitespace. You can't change metric_name after you create the rule Defaults to the same as name with disallowed characters removed
name - / required |  | Name of the Web Application Firewall rule
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
purge_conditions boolean | Choices: no ← yes | Whether or not to remove conditions that are not passed when updating `conditions`.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: present ← absent | whether the rule should be present or absent
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.
waf_regional boolean added in 2.9 | Choices: no ← yes | Whether to use waf_regional module. Defaults to false

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`

- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html

- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: create WAF rule
      aws_waf_rule:
        name: my_waf_rule
        conditions:
          - name: my_regex_condition
            type: regex
            negated: no
          - name: my_geo_condition
            type: geo
            negated: no
          - name: my_byte_condition
            type: byte
            negated: yes

    - name: remove WAF rule
      aws_waf_rule:
        name: "my_waf_rule"
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
rule complex | always | WAF rule contents
| metric_name string | always | Metric name for the rule Sample: ansibletest1234rule
| name string | always | Friendly name for the rule Sample: ansible-test-1234_rule
| predicates complex | always | List of conditions used in the rule
|  | data_id string | always | ID of the condition Sample: 8251acdb-526c-42a8-92bc-d3d13e584166
|  | negated boolean | always | Whether the sense of the condition is negated
|  | type string | always | type of the condition Sample: ByteMatch
| rule_id string | always | ID of the WAF rule Sample: 15de0cbc-9204-4e1f-90e6-69b2f415c261

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Mike Mochan (@mmochan)

- Will Thames (@willthames)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.